%define name lkcdutils
%define version 4.2
%define original_release 20040324
%define release 11AX

%define netdump 0

%{!?netdump:%define netdump 0}

Name: %{name}
Summary: Linux Kernel Crash Dump (LKCD) Utilities
Version: %{version}
Release: %{release}
Copyright: GPL
Group: Utilities/System
Source: %{name}-%{original_release}.tar.bz2
URL: http://oss.sgi.com/projects/lkcd/
Requires: ksymoops
Patch0: lkcdutils-4.2-sbin.lkcd.patch
Patch1: lkcdutils-4.2-sysconfig.patch
Patch2: lkcdutils-4.2-printversion.patch
Patch3: lkcdutils-4.2-invaliddump.patch
Patch4: lkcdutils-4.2-ps.sial.patch
Patch5: lkcdutils-4.2-ignoresymbol.patch
Patch6: lkcdutils-4.2-i386trace.patch
Patch7: lkcdutils-4.2-hugemem.patch
Patch8: lkcdutils-4.2-sbin.lkcd-modprobe.patch
Patch9: lkcdutils-4.2-print_log_buf.patch
Patch10: lkcdutils-4.2-task_struct.patch
Patch11: lkcdutils-4.2-ps.sial-2.patch
Patch12: lkcdutils-4.2-fix-runqueues-workaround.patch
Patch14: lkcdutils-4.2-hugemem-fix.patch
Patch20: lkcdutils-x86_64.patch
Patch22: lkcdutils-x86_64-fix.patch
Patch24: lkcdutils-x86_64-vmalloc.patch
Patch30: lkcdutils-ignore-unknown-symbol-type.patch
Patch31: lkcdutils-4.2-enforce-ioctl24.patch

Buildrequires: byacc,bison
Buildroot: /var/tmp/%{name}-root

%description
This software package contains system crash dump analyzer tools.
It includes Linux Crash (lcrash) and all appropriate user level
scripts required for saving and configuring system crash dumps.
This package should be installed after the lkcd kernel patches are
installed on the system.

%package devel
Summary: Header files and libraries of the lkcd project
Group: Development/System

%description devel
Useful libraries to write kernel analyzing tools like 'lcrash'.

%prep
%setup -q -n %{name}-%{original_release}
%patch0 -p1 
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
# fix print_log_buf()
%patch9 -p1
# fix for 2.6-backported task structure
%patch10 -p1
# ps.sial fix
%patch11 -p1
# suppress warning (workaround)
%patch12 -p1
# compile fix for the other archtectures
%patch14 -p1
# x86_64 support
%patch20 -p1
%patch22 -p1
%patch24 -p1
# ignore half-broken map generated by ksymoops
%patch30 -p1
# enforce not to define IOCTL26 in virbuild
%patch31 -p1

/bin/rm -r -f ${RPM_BUILD_ROOT}


%build
./configure --prefix=${RPM_BUILD_ROOT}
make

%if %{netdump}
cd netdump
make DESTDIR=${RPM_BUILD_ROOT}
cd ..
%endif

%install
mkdir -p ${RPM_BUILD_ROOT}/sbin
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1
%makeinstall

%if %{netdump}
%ifnarch s390 s390x
cd netdump
make DESTDIR=${RPM_BUILD_ROOT} install
%endif
%endif

%ifarch s390 s390x
# We do not need these files for s390 and s390x
rm -f	${RPM_BUILD_ROOT}/etc/sysconfig/dump \
	${RPM_BUILD_ROOT}/sbin/lkcd \
	${RPM_BUILD_ROOT}/sbin/lkcd_config \
	${RPM_BUILD_ROOT}/usr/man/man1/lkcd_config.1* 
%endif

%clean
test "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT

%files
%config /etc/sysconfig/dump
/sbin/lcrash
/usr/man/man1/lcrash.1*
/usr/share/sial/lcrash/ps.sial
%ifnarch s390 s390x
/sbin/lkcd
/sbin/lkcd_config
/usr/man/man1/lkcd_config.1*
%if %{netdump}
/usr/sbin/netdump-server
/etc/rc.d/init.d/netdump
/etc/rc.d/init.d/netdump-server
/usr/man/man8/netdump-server.8*
/usr/man/man8/netdump.8*
/var/crash/scripts
%endif
%endif

%files devel
/usr/lib/lkcd/libklib.a
/usr/lib/lkcd/liblkcd_rl.a
/usr/lib/lkcd/liblkcd_util.a
/usr/lib/lkcd/liblkcd_alloc.a
/usr/include/lkcd
/usr/lib/libsial.a
/usr/include/sial_api.h
/usr/include/sial.h

%changelog
* Mon Sep 26 2005 Akinobu Mita <mita@miraclelinux.com> 4.2-11AX
- make lcrash ignore unknown symbol type in system map generated by ksymoops.
- enforce not to use ioctl26 in virbuild.

* Tue Nov 08 2004 Akinobu Mita <mita@miraclelinux.com> 4.2-10AX
- fix for x86_64 specific vmalloc area

* Thu Nov 04 2004 Akinobu Mita <mita@miraclelinux.com> 4.2-9AX
- support for x86_64

* Thu Sep 30 2004 Akinobu Mita <mita@miraclelinux.com> 4.2-8AX
- fixed /sbin/lkcd to compile the lkcd as a module (#8)
- fixed for 2.6 backported changes (#9-#11)
- suppress many warning messages (#12)

* Mon Aug 30 2004 Akinobu Mita <mita@miraclelinux.com> 4.2-7AX
- VM layout fix for hugemem kernel

* Sun Apr 25 2004 Tatsuo Ito <tito@miraclelinux.com> 4.2-6AX
- %config -> /etc/sysconfig/dump

* Wed Apr 21 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.2-5AX
- fixed i386-trace algorithm(Patch No.6)

* Thu Mar 25 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.2-4AX
- fixed ps command of lcrash(Patch No.4)
- added ignore symole type 'q'(Patch No.5)

* Thu Mar 25 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.2-3AX
- added requires tag of ksymoops
- removed netdump function by the default

* Wed Mar 24 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.2-2AX
- fixed /sbin/lkcd (Patch No.0)
- changed the default setting of /etc/sysconfig/dump(Patch No.1)
- fixed usage is shown in startup(Patch No.2)
- fixed handling with invalid dump(Patch No.3)

* Wed Mar 24 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.2-1AX
- updated for Asianux
